<!DOCTYPE html>

<html lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="generator" content="Docutils 0.5: http://docutils.sourceforge.net/">
<title>Bitten: Build Recipe Commands</title>
<link rel="stylesheet" href="common/style/edgewall.css" type="text/css">
</head>
<body>
<div class="document" id="build-recipe-commands">
    <div id="navigation">
      <span class="projinfo">Bitten 0.6</span>
      <a href="index.html">Documentation Index</a>
    </div>
<h1 class="title">Build Recipe Commands</h1>
<p><a class="reference external" href="recipes.html">Build recipes</a> are represented by XML documents. This page describes what
commands are generally available in recipes, and any <a class="reference external" href="configure.html">runtime configuration</a>
supported by these commands. Please note, though, that
third-party packages can add additional commands, which would then be
documented by that third party.</p>
<div class="contents topic" id="contents">
<p class="topic-title first">Contents</p>
<ul class="auto-toc simple">
<li><a class="reference internal" href="#generic-commands" id="id56">1   Generic Commands</a><ul class="auto-toc">
<li><a class="reference internal" href="#report" id="id57">1.1   <tt class="docutils literal"><span class="pre">&lt;report&gt;</span></tt></a></li>
<li><a class="reference internal" href="#attach" id="id58">1.2   <tt class="docutils literal"><span class="pre">&lt;attach&gt;</span></tt></a></li>
</ul>
</li>
<li><a class="reference internal" href="#shell-tools" id="id59">2   Shell Tools</a><ul class="auto-toc">
<li><a class="reference internal" href="#sh-exec" id="id60">2.1   <tt class="docutils literal"><span class="pre">&lt;sh:exec&gt;</span></tt></a></li>
<li><a class="reference internal" href="#sh-pipe" id="id61">2.2   <tt class="docutils literal"><span class="pre">&lt;sh:pipe&gt;</span></tt></a></li>
</ul>
</li>
<li><a class="reference internal" href="#c-unix-tools" id="id62">3   C/Unix Tools</a><ul class="auto-toc">
<li><a class="reference internal" href="#c-autoreconf" id="id63">3.1   <tt class="docutils literal"><span class="pre">&lt;c:autoreconf&gt;</span></tt></a></li>
<li><a class="reference internal" href="#c-configure" id="id64">3.2   <tt class="docutils literal"><span class="pre">&lt;c:configure&gt;</span></tt></a></li>
<li><a class="reference internal" href="#c-gcov" id="id65">3.3   <tt class="docutils literal"><span class="pre">&lt;c:gcov&gt;</span></tt></a></li>
<li><a class="reference internal" href="#c-make" id="id66">3.4   <tt class="docutils literal"><span class="pre">&lt;c:make&gt;</span></tt></a></li>
<li><a class="reference internal" href="#c-cppunit" id="id67">3.5   <tt class="docutils literal"><span class="pre">&lt;c:cppunit&gt;</span></tt></a></li>
</ul>
</li>
<li><a class="reference internal" href="#java-tools" id="id68">4   Java Tools</a><ul class="auto-toc">
<li><a class="reference internal" href="#java-ant" id="id69">4.1   <tt class="docutils literal"><span class="pre">&lt;java:ant&gt;</span></tt></a></li>
<li><a class="reference internal" href="#java-cobertura" id="id70">4.2   <tt class="docutils literal"><span class="pre">&lt;java:cobertura&gt;</span></tt></a></li>
<li><a class="reference internal" href="#java-junit" id="id71">4.3   <tt class="docutils literal"><span class="pre">&lt;java:junit&gt;</span></tt></a></li>
</ul>
</li>
<li><a class="reference internal" href="#mono-tools" id="id72">5   Mono Tools</a><ul class="auto-toc">
<li><a class="reference internal" href="#mono-nunit" id="id73">5.1   <tt class="docutils literal"><span class="pre">&lt;mono:nunit&gt;</span></tt></a></li>
</ul>
</li>
<li><a class="reference internal" href="#php-tools" id="id74">6   PHP Tools</a><ul class="auto-toc">
<li><a class="reference internal" href="#php-phing" id="id75">6.1   <tt class="docutils literal"><span class="pre">&lt;php:phing&gt;</span></tt></a></li>
<li><a class="reference internal" href="#php-phpunit" id="id76">6.2   <tt class="docutils literal"><span class="pre">&lt;php:phpunit&gt;</span></tt></a></li>
<li><a class="reference internal" href="#php-coverage" id="id77">6.3   <tt class="docutils literal"><span class="pre">&lt;php:coverage&gt;</span></tt></a></li>
</ul>
</li>
<li><a class="reference internal" href="#python-tools" id="id78">7   Python Tools</a><ul class="auto-toc">
<li><a class="reference internal" href="#python-exec" id="id79">7.1   <tt class="docutils literal"><span class="pre">&lt;python:exec&gt;</span></tt></a></li>
<li><a class="reference internal" href="#python-distutils" id="id80">7.2   <tt class="docutils literal"><span class="pre">&lt;python:distutils&gt;</span></tt></a></li>
<li><a class="reference internal" href="#python-unittest" id="id81">7.3   <tt class="docutils literal"><span class="pre">&lt;python:unittest&gt;</span></tt></a></li>
<li><a class="reference internal" href="#python-trace" id="id82">7.4   <tt class="docutils literal"><span class="pre">&lt;python:trace&gt;</span></tt></a></li>
<li><a class="reference internal" href="#python-coverage" id="id83">7.5   <tt class="docutils literal"><span class="pre">&lt;python:coverage&gt;</span></tt></a></li>
<li><a class="reference internal" href="#python-figleaf" id="id84">7.6   <tt class="docutils literal"><span class="pre">&lt;python:figleaf&gt;</span></tt></a></li>
<li><a class="reference internal" href="#python-pylint" id="id85">7.7   <tt class="docutils literal"><span class="pre">&lt;python:pylint&gt;</span></tt></a></li>
</ul>
</li>
<li><a class="reference internal" href="#subversion-tools" id="id86">8   Subversion Tools</a><ul class="auto-toc">
<li><a class="reference internal" href="#svn-checkout" id="id87">8.1   <tt class="docutils literal"><span class="pre">&lt;svn:checkout&gt;</span></tt></a></li>
<li><a class="reference internal" href="#svn-export" id="id88">8.2   <tt class="docutils literal"><span class="pre">&lt;svn:export&gt;</span></tt></a></li>
<li><a class="reference internal" href="#svn-update" id="id89">8.3   <tt class="docutils literal"><span class="pre">&lt;svn:update&gt;</span></tt></a></li>
</ul>
</li>
<li><a class="reference internal" href="#xml-tools" id="id90">9   XML Tools</a><ul class="auto-toc">
<li><a class="reference internal" href="#x-transform" id="id91">9.1   <tt class="docutils literal"><span class="pre">&lt;x:transform&gt;</span></tt></a></li>
</ul>
</li>
<li><a class="reference internal" href="#mercurial-tools" id="id92">10   Mercurial Tools</a><ul class="auto-toc">
<li><a class="reference internal" href="#hg-pull" id="id93">10.1   <tt class="docutils literal"><span class="pre">&lt;hg:pull&gt;</span></tt></a></li>
</ul>
</li>
</ul>
</div>
<div class="section" id="generic-commands">
<h1>1   Generic Commands</h1>
<p>These are commands that are used without a namespace prefix.</p>
<div class="section" id="report">
<h2>1.1   <tt class="docutils literal"><span class="pre">&lt;report&gt;</span></tt></h2>
<p>Parse an XML file and send it to the master as a report with a given category.
Use this command in conjunction with the <tt class="docutils literal"><span class="pre">&lt;sh:pipe&gt;</span></tt> or <tt class="docutils literal"><span class="pre">&lt;x:transform&gt;</span></tt>
commands to send custom reports to the build master.</p>
<div class="section" id="parameters">
<h3>1.1.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="19%">
<col width="81%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">category</span></tt></td>
<td>Category of the report (for example "test" or "coverage").</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">file</span></tt></td>
<td>Path to the XML file containing the report data, relative
to the project directory.</td>
</tr>
</tbody>
</table>
<p>Both parameters must be specified.</p>
<p>See also <a class="reference external" href="reports.html">Report Formats</a>.</p>
</div>
</div>
<div class="section" id="attach">
<h2>1.2   <tt class="docutils literal"><span class="pre">&lt;attach&gt;</span></tt></h2>
<p>Attach a file to the build or configuration as regular attachment. An already
existing attachment on the same resource with same base filename will be
replaced.</p>
<p><strong>Note:</strong> Unless consistently building latest only, overwriting files on
config level may lead to unexpected results.</p>
<div class="section" id="id1">
<h3>1.2.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="23%">
<col width="77%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">file</span></tt></td>
<td>Path to the file to attach, relative to the project
directory.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">resource</span></tt></td>
<td>The resource to attach the file to. Either
'build' (default) or 'config'. Optional.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">description</span></tt></td>
<td>Attachment description. Optional.</td>
</tr>
</tbody>
</table>
</div>
</div>
</div>
<div class="section" id="shell-tools">
<h1>2   Shell Tools</h1>
<p>A bundle of generic tools that are not specific to any programming language or
tool-chain.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name">
<col class="field-body">
<tbody valign="top">
<tr class="field"><th class="field-name">Namespace:</th><td class="field-body"><tt class="docutils literal"><span class="pre">http://bitten.edgewall.org/tools/sh</span></tt></td>
</tr>
<tr class="field"><th class="field-name">Common prefix:</th><td class="field-body"><tt class="docutils literal"><span class="pre">sh</span></tt></td>
</tr>
</tbody>
</table>
<div class="section" id="sh-exec">
<h2>2.1   <tt class="docutils literal"><span class="pre">&lt;sh:exec&gt;</span></tt></h2>
<p>Executes a program or script.</p>
<div class="section" id="id2">
<h3>2.1.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="21%">
<col width="79%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">executable</span></tt></td>
<td>The name of the executable program.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">file</span></tt></td>
<td>Path to the script to execute, relative to the project
directory</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">output</span></tt></td>
<td>Path to the output file</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">args</span></tt></td>
<td>Any arguments to pass to the executable or script</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">dir</span></tt></td>
<td>Directory to change to before executing the command</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">timeout</span></tt></td>
<td>Limits the runtime of this command to the specified
number of seconds, after which it will be terminated.</td>
</tr>
</tbody>
</table>
<p>Either <tt class="docutils literal"><span class="pre">executable</span></tt> or <tt class="docutils literal"><span class="pre">file</span></tt> must be specified.</p>
</div>
<div class="section" id="examples">
<h3>2.1.2   Examples</h3>
<p>TODO</p>
</div>
</div>
<div class="section" id="sh-pipe">
<h2>2.2   <tt class="docutils literal"><span class="pre">&lt;sh:pipe&gt;</span></tt></h2>
<p>Pipes the content of a file through a program or script.</p>
<div class="section" id="id3">
<h3>2.2.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="21%">
<col width="79%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">executable</span></tt></td>
<td>The name of the executable program.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">file</span></tt></td>
<td>Path to the script to execute, relative to the project
directory</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">input</span></tt></td>
<td>Path to the input file</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">output</span></tt></td>
<td>Path to the output file</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">args</span></tt></td>
<td>Any arguments to pass to the executable or script</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">dir</span></tt></td>
<td>Directory to change to before executing the command</td>
</tr>
</tbody>
</table>
<p>Either <tt class="docutils literal"><span class="pre">executable</span></tt> or <tt class="docutils literal"><span class="pre">file</span></tt> must be specified.</p>
</div>
<div class="section" id="id4">
<h3>2.2.2   Examples</h3>
<p>TODO</p>
</div>
</div>
</div>
<div class="section" id="c-unix-tools">
<h1>3   C/Unix Tools</h1>
<p>These commands provide support for tools commonly used for development of C/C++
applications on Unix platforms, such as <tt class="docutils literal"><span class="pre">make</span></tt>.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name">
<col class="field-body">
<tbody valign="top">
<tr class="field"><th class="field-name">Namespace:</th><td class="field-body"><tt class="docutils literal"><span class="pre">http://bitten.edgewall.org/tools/c</span></tt></td>
</tr>
<tr class="field"><th class="field-name">Common prefix:</th><td class="field-body"><tt class="docutils literal"><span class="pre">c</span></tt></td>
</tr>
</tbody>
</table>
<div class="section" id="c-autoreconf">
<h2>3.1   <tt class="docutils literal"><span class="pre">&lt;c:autoreconf&gt;</span></tt></h2>
<p>Executes ths autotool autoreconf.</p>
<div class="section" id="id5">
<h3>3.1.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="29%">
<col width="71%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">force</span></tt></td>
<td>Consider all files obsolete</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">install</span></tt></td>
<td>Copy missing auxiliary files</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">symlink</span></tt></td>
<td>Install symbolic links instead of copies</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">warnings</span></tt></td>
<td>Report the warnings related to category
(which can actually be a comma separated list)</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">prepend_include</span></tt></td>
<td>Prepend directories to search path</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">include</span></tt></td>
<td>Append directories to search path</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="id6">
<h3>3.1.2   Examples</h3>
<div class="highlight"><pre><span class="nt">&lt;c:autoreconf</span> <span class="na">force=</span><span class="s">"1"</span> <span class="na">install=</span><span class="s">"1"</span> <span class="na">warnings=</span><span class="s">"cross,syntax,error"</span><span class="nt">/&gt;</span>
</pre></div>
<p>Runs the <tt class="docutils literal"><span class="pre">autoreconf</span></tt> tool in the base directory with the option: force, install
and 3 warning categories active: cross,syntax,error. This is equivalent to:</p>
<pre class="literal-block">
autoreconf --force --install --warnings=cross,syntax,error
</pre>
</div>
</div>
<div class="section" id="c-configure">
<h2>3.2   <tt class="docutils literal"><span class="pre">&lt;c:configure&gt;</span></tt></h2>
<p>Executes a configure script as generated by Autoconf.</p>
<div class="section" id="id7">
<h3>3.2.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="19%">
<col width="81%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">file</span></tt></td>
<td>Name of the configure script (defaults to "configure")</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">enable</span></tt></td>
<td>List of features to enable, separated by spaces.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">disable</span></tt></td>
<td>List of features to disable, separated by spaces.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">with</span></tt></td>
<td>List of packages to include, separated by spaces.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">without</span></tt></td>
<td>List of packages to exclude, separated by spaces.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">cflags</span></tt></td>
<td>Value of the <cite>CFLAGS</cite> variable to pass to the script.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">cxxflags</span></tt></td>
<td>Value of the <cite>CXXFLAGS</cite> variable to pass to the script.</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="id8">
<h3>3.2.2   Examples</h3>
<div class="highlight"><pre><span class="nt">&lt;c:configure</span> <span class="na">enable=</span><span class="s">"threadsafe"</span> <span class="na">cflags=</span><span class="s">"-O"</span><span class="nt">/&gt;</span>
</pre></div>
<p>Runs the <tt class="docutils literal"><span class="pre">configure</span></tt> script in the base directory, enable the <tt class="docutils literal"><span class="pre">threadsafe</span></tt>
feature, and passing <tt class="docutils literal"><span class="pre">-O</span></tt> as <tt class="docutils literal"><span class="pre">CFLAGS</span></tt>. This is equivalent to:</p>
<pre class="literal-block">
./configure --enable-threadsafe CFLAGS="-O"
</pre>
</div>
<div class="section" id="configuration">
<h3>3.2.3   Configuration</h3>
<p>Parameter <tt class="docutils literal"><span class="pre">with</span></tt> will expand any package found in slave configuration:</p>
<div class="highlight"><pre><span class="k">[mylib]</span>
<span class="na">path</span> <span class="o">=</span> <span class="s">/path/to/mylib</span>
</pre></div>
</div>
</div>
<div class="section" id="c-gcov">
<h2>3.3   <tt class="docutils literal"><span class="pre">&lt;c:gcov&gt;</span></tt></h2>
<p>Run <a class="reference external" href="http://gcc.gnu.org/onlinedocs/gcc/Gcov-Intro.html">gcov</a> to extract coverage data where available.</p>
<div class="section" id="id9">
<h3>3.3.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="19%">
<col width="81%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">include</span></tt></td>
<td>List of glob patterns (separated by space) that specify
which source files should be included in the coverage
report</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">exclude</span></tt></td>
<td>List of glob patterns (separated by space) that specify
which source files should be excluded from the coverage
report</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">prefix</span></tt></td>
<td>Optional prefix name that is added to object files by the
build system</td>
</tr>
</tbody>
</table>
</div>
</div>
<div class="section" id="c-make">
<h2>3.4   <tt class="docutils literal"><span class="pre">&lt;c:make&gt;</span></tt></h2>
<p>Executes a Makefile.</p>
<div class="section" id="id10">
<h3>3.4.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="21%">
<col width="79%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">target</span></tt></td>
<td>Name of the target to execute (defaults to "all")</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">file</span></tt></td>
<td>Path to the Makefile that should be used.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">keep-going</span></tt></td>
<td>Whether <cite>make</cite> should try to continue even after
encountering errors.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">jobs</span></tt></td>
<td>Number of parallel jobs used by make.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">directory</span></tt></td>
<td>Path of the directory in which make should be called.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">args</span></tt></td>
<td>Any space separated arguments to pass to the makefile.
Usually in the form:
<tt class="docutils literal"><span class="pre">"parameter1=value1</span> <span class="pre">parameter2=value2"</span></tt>.</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="id11">
<h3>3.4.2   Examples</h3>
<div class="highlight"><pre><span class="nt">&lt;c:make</span> <span class="na">target=</span><span class="s">"compile"</span> <span class="na">file=</span><span class="s">"build/Makefile"</span> <span class="nt">/&gt;</span>
</pre></div>
<p>Runs the target "compile" of the <tt class="docutils literal"><span class="pre">Makefile</span></tt> located in the sub-directory
<tt class="docutils literal"><span class="pre">build</span></tt>.</p>
<div class="highlight"><pre><span class="nt">&lt;c:make</span> <span class="na">target=</span><span class="s">"compile"</span> <span class="na">file=</span><span class="s">"build/Makefile"</span> <span class="na">directory=</span><span class="s">"work"</span> <span class="na">args=</span><span class="s">"coverage=1"</span> <span class="nt">/&gt;</span>
</pre></div>
<p>Same as previous but execute the command in the <tt class="docutils literal"><span class="pre">work</span></tt> directory and call
the makefile with the command line argument <tt class="docutils literal"><span class="pre">coverage=1</span></tt>.</p>
</div>
<div class="section" id="id12">
<h3>3.4.3   Configuration</h3>
<div class="highlight"><pre><span class="k">[make]</span>
<span class="na">path</span> <span class="o">=</span> <span class="s">/path/to/(c|n)make</span>
</pre></div>
</div>
</div>
<div class="section" id="c-cppunit">
<h2>3.5   <tt class="docutils literal"><span class="pre">&lt;c:cppunit&gt;</span></tt></h2>
<p>Report the test output generated by the <a class="reference external" href="http://cppunit.sourceforge.net">CppUnit</a> unit testing framework. The
output from CppUnit must be in XML format and in already, specified by the
<tt class="docutils literal"><span class="pre">file</span></tt> argument of this recipe.</p>
<div class="section" id="id13">
<h3>3.5.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="21%">
<col width="79%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">file</span></tt></td>
<td>Path to the cppunit XML output file.</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="id14">
<h3>3.5.2   Examples</h3>
<div class="highlight"><pre><span class="nt">&lt;sh:exec</span> <span class="na">executable=</span><span class="s">"run_unit_tests"</span> <span class="na">output=</span><span class="s">"test_results.xml"</span> <span class="nt">/&gt;</span>
<span class="nt">&lt;c:cppunit</span> <span class="na">file=</span><span class="s">"test_results.xml"</span> <span class="nt">/&gt;</span>
</pre></div>
<p>Runs the program <tt class="docutils literal"><span class="pre">run_unit_tests</span></tt> to gather the data output by CppUnit in the
<tt class="docutils literal"><span class="pre">test_results.xml</span></tt> file and then reports it.</p>
</div>
</div>
</div>
<div class="section" id="java-tools">
<h1>4   Java Tools</h1>
<p>A bundle of recipe commands that support tools commonly used by Java projects.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name">
<col class="field-body">
<tbody valign="top">
<tr class="field"><th class="field-name">Namespace:</th><td class="field-body"><tt class="docutils literal"><span class="pre">http://bitten.edgewall.org/tools/java</span></tt></td>
</tr>
<tr class="field"><th class="field-name">Common prefix:</th><td class="field-body"><tt class="docutils literal"><span class="pre">java</span></tt></td>
</tr>
</tbody>
</table>
<div class="section" id="java-ant">
<h2>4.1   <tt class="docutils literal"><span class="pre">&lt;java:ant&gt;</span></tt></h2>
<p>Runs an <a class="reference external" href="http://ant.apache.org/">Ant</a> build.</p>
<div class="section" id="id15">
<h3>4.1.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="21%">
<col width="79%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">file</span></tt></td>
<td>Path of the build file, relative to the project source
directory (default is <tt class="docutils literal"><span class="pre">build.xml</span></tt>).</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">target</span></tt></td>
<td>Name of the build target(s) to execute.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">args</span></tt></td>
<td>Additional arguments to pass to Ant, separated by
whitespace.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">keep_going</span></tt></td>
<td>Tell Ant to continue even when errors are in encountered
in the build.</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="id16">
<h3>4.1.2   Examples</h3>
<div class="highlight"><pre><span class="nt">&lt;java:ant</span> <span class="na">target=</span><span class="s">"compile"</span> <span class="nt">/&gt;</span>
</pre></div>
<p>Executes the target <tt class="docutils literal"><span class="pre">compile</span></tt> of the <tt class="docutils literal"><span class="pre">build.xml</span></tt> buildfile at the top of the
project source directory.</p>
</div>
<div class="section" id="id17">
<h3>4.1.3   Configuration</h3>
<div class="highlight"><pre><span class="k">[ant]</span>
<span class="na">home</span> <span class="o">=</span> <span class="s">/path/to/ant/dir</span>

<span class="k">[java]</span>
<span class="na">home</span> <span class="o">=</span> <span class="s">/path/to/java/dir</span>
</pre></div>
</div>
</div>
<div class="section" id="java-cobertura">
<h2>4.2   <tt class="docutils literal"><span class="pre">&lt;java:cobertura&gt;</span></tt></h2>
<p>Extract code coverage data from a <a class="reference external" href="http://cobertura.sourceforge.net/">Cobertura</a> XML file.</p>
<div class="section" id="id18">
<h3>4.2.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="21%">
<col width="79%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">file</span></tt></td>
<td>Path to the XML file generated by Cobertura</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="id19">
<h3>4.2.2   Examples</h3>
<div class="highlight"><pre><span class="nt">&lt;java:cobertura</span> <span class="na">file=</span><span class="s">"build/cobertura.xml"</span> <span class="nt">/&gt;</span>
</pre></div>
<p>Reads the specifid XML file, extracts the coverage data, and builds a coverage
report to be sent to the build master.</p>
</div>
</div>
<div class="section" id="java-junit">
<h2>4.3   <tt class="docutils literal"><span class="pre">&lt;java:junit&gt;</span></tt></h2>
<p>Extracts information about unit test results from a file in <a class="reference external" href="http://junit.org/index.htm">JUnit</a> XML format.</p>
<div class="section" id="id20">
<h3>4.3.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="21%">
<col width="79%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">file</span></tt></td>
<td>Path to the JUnit XML test results file. This can include
wildcards, in which case all the file matching the
pattern will be included.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">srcdir</span></tt></td>
<td>Path of the directory unit test sources. Used to link the
test cases to files.</td>
</tr>
</tbody>
</table>
<p>The <tt class="docutils literal"><span class="pre">file</span></tt> attribute is required.</p>
</div>
<div class="section" id="id21">
<h3>4.3.2   Examples</h3>
<div class="highlight"><pre><span class="nt">&lt;java:junit</span> <span class="na">file=</span><span class="s">"build/tests/results/TEST-*.xml"</span> <span class="na">srcdir=</span><span class="s">"src/tests"</span> <span class="nt">/&gt;</span>
</pre></div>
<p>Collects the test results from all files in the <cite>build/tests/results</cite> directory
that match the pattern <cite>TEST-*.xml</cite>. Also, maps the class names in the results
files to Java source files in the directory <cite>src/tests</cite>.</p>
</div>
</div>
</div>
<div class="section" id="mono-tools">
<h1>5   Mono Tools</h1>
<p>A bundle of recipe commands that support tools commonly used by Mono/.NET projects.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name">
<col class="field-body">
<tbody valign="top">
<tr class="field"><th class="field-name">Namespace:</th><td class="field-body"><tt class="docutils literal"><span class="pre">http://bitten.edgewall.org/tools/mono</span></tt></td>
</tr>
<tr class="field"><th class="field-name">Common prefix:</th><td class="field-body"><tt class="docutils literal"><span class="pre">mono</span></tt></td>
</tr>
</tbody>
</table>
<div class="section" id="mono-nunit">
<h2>5.1   <tt class="docutils literal"><span class="pre">&lt;mono:nunit&gt;</span></tt></h2>
<p>Extracts information about unit test results from a files in <a class="reference external" href="http://nunit.org/">NUnit</a> XML format.</p>
<div class="section" id="id22">
<h3>5.1.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="21%">
<col width="79%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">file</span></tt></td>
<td>Path to the NUnit XML test results file. This can include
wildcards, in which case all the file matching the
pattern will be included.</td>
</tr>
</tbody>
</table>
<p>The <tt class="docutils literal"><span class="pre">file</span></tt> attribute is required.</p>
</div>
<div class="section" id="id23">
<h3>5.1.2   Examples</h3>
<div class="highlight"><pre><span class="nt">&lt;mono:nunit</span> <span class="na">file=</span><span class="s">"build/tests/TestResult.xml"</span> <span class="nt">/&gt;</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="php-tools">
<h1>6   PHP Tools</h1>
<p>A bundle of recipe commands for <a class="reference external" href="http://php.net/">PHP</a> projects.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name">
<col class="field-body">
<tbody valign="top">
<tr class="field"><th class="field-name">Namespace:</th><td class="field-body"><tt class="docutils literal"><span class="pre">http://bitten.edgewall.org/tools/php</span></tt></td>
</tr>
<tr class="field"><th class="field-name">Common prefix:</th><td class="field-body"><tt class="docutils literal"><span class="pre">php</span></tt></td>
</tr>
</tbody>
</table>
<div class="section" id="php-phing">
<h2>6.1   <tt class="docutils literal"><span class="pre">&lt;php:phing&gt;</span></tt></h2>
<p>Runs a <a class="reference external" href="http://phing.info/">Phing</a> build.</p>
<div class="section" id="id24">
<h3>6.1.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="26%">
<col width="74%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">file</span></tt></td>
<td>Path of the build file, relative to the project
source directory (default is <tt class="docutils literal"><span class="pre">build.xml</span></tt>).</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">target</span></tt></td>
<td>Name of the build target(s) to execute.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">args</span></tt></td>
<td>Additional arguments to pass to Phing, separated by
whitespace.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">executable</span></tt></td>
<td>Phing executable program (default is <tt class="docutils literal"><span class="pre">phing</span></tt>).</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="id25">
<h3>6.1.2   Examples</h3>
<div class="highlight"><pre><span class="nt">&lt;php:phing</span> <span class="na">target=</span><span class="s">"compile"</span> <span class="nt">/&gt;</span>
</pre></div>
<p>Executes the target <tt class="docutils literal"><span class="pre">compile</span></tt> of the <tt class="docutils literal"><span class="pre">build.xml</span></tt> buildfile at the top of the
project source directory.</p>
</div>
</div>
<div class="section" id="php-phpunit">
<h2>6.2   <tt class="docutils literal"><span class="pre">&lt;php:phpunit&gt;</span></tt></h2>
<p>Extracts information from <a class="reference external" href="http://www.phpunit.de/">PHPUnit</a> test results recorded in an XML file.</p>
<div class="section" id="id26">
<h3>6.2.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="21%">
<col width="79%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">file</span></tt></td>
<td>Path to the XML results file, relative to the project
source directory.</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="id27">
<h3>6.2.2   Examples</h3>
<div class="highlight"><pre><span class="nt">&lt;php:phpunit</span> <span class="na">file=</span><span class="s">"build/test-results.xml"</span><span class="nt">/&gt;</span>
</pre></div>
<p>Extracts the test results from the XML file located at
<tt class="docutils literal"><span class="pre">build/test-results.xml</span></tt>.</p>
</div>
</div>
<div class="section" id="php-coverage">
<h2>6.3   <tt class="docutils literal"><span class="pre">&lt;php:coverage&gt;</span></tt></h2>
<p>Extracts coverage information from <a class="reference external" href="http://phing.info/">Phing</a>'s code coverage task XML file or
from <a class="reference external" href="http://www.phpunit.de/">PHPUnit</a> coverage-clover XML file.</p>
<div class="section" id="id28">
<h3>6.3.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="20%">
<col width="80%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">file</span></tt></td>
<td>Path to the XML coverage file, relative to the project
source directory.</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="id29">
<h3>6.3.2   Examples</h3>
<div class="highlight"><pre><span class="nt">&lt;php:coverage</span> <span class="na">file=</span><span class="s">"build/coverage.xml"</span> <span class="nt">/&gt;</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="python-tools">
<h1>7   Python Tools</h1>
<p>A bundle of recipe commands that support tools commonly used by <a class="reference external" href="http://www.python.org/">Python</a>
projects.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name">
<col class="field-body">
<tbody valign="top">
<tr class="field"><th class="field-name">Namespace:</th><td class="field-body"><tt class="docutils literal"><span class="pre">http://bitten.edgewall.org/tools/python</span></tt></td>
</tr>
<tr class="field"><th class="field-name">Common prefix:</th><td class="field-body"><tt class="docutils literal"><span class="pre">python</span></tt></td>
</tr>
</tbody>
</table>
<div class="section" id="python-exec">
<h2>7.1   <tt class="docutils literal"><span class="pre">&lt;python:exec&gt;</span></tt></h2>
<p>Executes a Python script.</p>
<div class="section" id="id30">
<h3>7.1.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="21%">
<col width="79%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">file</span></tt></td>
<td>Path of the script to execute, relative to the project
source directory.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">module</span></tt></td>
<td>Name of the Python module to execute.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">function</span></tt></td>
<td>Name of the function in the Python module to run. Only
works when also specifying the <cite>module</cite> attribute.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">args</span></tt></td>
<td>Any arguments that should be passed to the script.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">output</span></tt></td>
<td>Path to a file where any output by the script should be
recorded.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">timeout</span></tt></td>
<td>Limits the runtime of this command to the specified
number of seconds, after which it will be terminated.</td>
</tr>
</tbody>
</table>
<p>Either <cite>file</cite> or <cite>module</cite> must be specified.</p>
</div>
<div class="section" id="id31">
<h3>7.1.2   Examples</h3>
<div class="highlight"><pre><span class="nt">&lt;python:exec</span> <span class="na">module=</span><span class="s">"pylint.lint"</span> <span class="na">output=</span><span class="s">"pylint-report.txt"</span> <span class="na">args=</span><span class="s">"myproj"</span> <span class="nt">/&gt;</span>
</pre></div>
<p>Executes <a class="reference external" href="http://www.logilab.org/projects/pylint">Pylint</a> on the module/package <tt class="docutils literal"><span class="pre">myproj</span></tt> and stores the output into a
file named <tt class="docutils literal"><span class="pre">pylint-report.txt</span></tt>.</p>
</div>
<div class="section" id="id32">
<h3>7.1.3   Configuration</h3>
<div class="highlight"><pre><span class="k">[python]</span>
<span class="na">path</span> <span class="o">=</span> <span class="s">/path/to/python</span>
</pre></div>
</div>
</div>
<div class="section" id="python-distutils">
<h2>7.2   <tt class="docutils literal"><span class="pre">&lt;python:distutils&gt;</span></tt></h2>
<p>Executes a <a class="reference external" href="http://docs.python.org/lib/module-distutils.html">distutils</a> script.</p>
<div class="section" id="id33">
<h3>7.2.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="21%">
<col width="79%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><cite>command</cite></td>
<td>The name of the <cite>distutils</cite> command that should be run</td>
</tr>
<tr><td><cite>options</cite></td>
<td>Additional options to pass to the command, separated by
spaces</td>
</tr>
<tr><td><cite>timeout</cite></td>
<td>Limits the runtime of this command to the specified
number of seconds, after which it will be terminated.</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="id34">
<h3>7.2.2   Examples</h3>
<div class="highlight"><pre><span class="nt">&lt;python:distutils</span> <span class="na">command=</span><span class="s">"sdist"</span> <span class="nt">/&gt;</span>
</pre></div>
<p>Instructs <cite>distutils</cite> to produce a source distribution.</p>
<div class="highlight"><pre><span class="nt">&lt;python:distutils</span> <span class="na">command=</span><span class="s">"unittest"</span> <span class="na">options=</span><span class="s">"</span>
<span class="s">    --xml-output build/test-results.xml</span>
<span class="s">    --coverage-summary build/test-coverage.txt</span>
<span class="s">    --coverage-dir build/coverage</span>
<span class="s">    --coverage-method trace"</span><span class="nt">/&gt;</span>
</pre></div>
<p>Instructs <cite>distutils</cite> to run the <tt class="docutils literal"><span class="pre">unittest</span></tt> command (which is provided by
Bitten), and passes the options needed to determine the output paths for test
results and code coverage reports.</p>
<p>Option <tt class="docutils literal"><span class="pre">--coverage-method</span></tt> is one of <tt class="docutils literal"><span class="pre">trace</span></tt>, <tt class="docutils literal"><span class="pre">coverage</span></tt> or <tt class="docutils literal"><span class="pre">figleaf</span></tt>.</p>
</div>
<div class="section" id="id35">
<h3>7.2.3   Configuration</h3>
<div class="highlight"><pre><span class="k">[python]</span>
<span class="na">path</span> <span class="o">=</span> <span class="s">/path/to/python</span>
</pre></div>
</div>
</div>
<div class="section" id="python-unittest">
<h2>7.3   <tt class="docutils literal"><span class="pre">&lt;python:unittest&gt;</span></tt></h2>
<p>Extracts information from <a class="reference external" href="http://docs.python.org/lib/module-unittest.html">unittest</a> results recorded in an XML file.</p>
<p><strong>Note:</strong> This report must be used in conjunction with the <tt class="docutils literal"><span class="pre">distutils</span></tt>
command "unittest" that comes with Bitten.</p>
<div class="section" id="id36">
<h3>7.3.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="21%">
<col width="79%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">file</span></tt></td>
<td>Path to the XML results file, relative to the project
source directory.</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="id37">
<h3>7.3.2   Examples</h3>
<div class="highlight"><pre><span class="nt">&lt;python:unittest</span> <span class="na">file=</span><span class="s">"build/test-results.xml"</span><span class="nt">/&gt;</span>
</pre></div>
<p>Extracts the test results from the XML file located at
<tt class="docutils literal"><span class="pre">build/test-results.xml</span></tt>.</p>
</div>
</div>
<div class="section" id="python-trace">
<h2>7.4   <tt class="docutils literal"><span class="pre">&lt;python:trace&gt;</span></tt></h2>
<p>Extracts coverage information recorded by the built-in Python module
<tt class="docutils literal"><span class="pre">trace.py</span></tt>.</p>
<div class="section" id="id38">
<h3>7.4.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="19%">
<col width="81%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">summary</span></tt></td>
<td>Path to the summary file written by <tt class="docutils literal"><span class="pre">trace.py</span></tt>,
relative to the project source directory.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">coverdir</span></tt></td>
<td>Path to the directory containing the coverage files written
by <tt class="docutils literal"><span class="pre">trace.py</span></tt>, relative to the project source directory.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">include</span></tt></td>
<td>List of glob patterns (separated by space) that specify
which Python file should be included in the coverage report</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">exclude</span></tt></td>
<td>List of glob patterns (separated by space) that specify
which Python file should be excluded from the coverage
report</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="id39">
<h3>7.4.2   Examples</h3>
<div class="highlight"><pre><span class="nt">&lt;python:trace</span> <span class="na">summary=</span><span class="s">"build/trace.out"</span> <span class="na">coverdir=</span><span class="s">"build/coverage"</span> <span class="nt">/&gt;</span>
</pre></div>
</div>
</div>
<div class="section" id="python-coverage">
<h2>7.5   <tt class="docutils literal"><span class="pre">&lt;python:coverage&gt;</span></tt></h2>
<p>Extract data from a <a class="reference external" href="http://nedbatchelder.com/code/coverage/">coverage.py</a> run.</p>
<div class="section" id="id40">
<h3>7.5.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="19%">
<col width="81%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">summary</span></tt></td>
<td>Path to the summary file with <tt class="docutils literal"><span class="pre">coverage.py</span></tt> information,
relative to the project source directory.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">coverdir</span></tt></td>
<td>Path to the directory containing per-module coverage
details, relative to the project source directory.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">include</span></tt></td>
<td>List of glob patterns (separated by space) that specify
which Python file should be included in the coverage report</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">exclude</span></tt></td>
<td>List of glob patterns (separated by space) that specify
which Python file should be excluded from the coverage
report</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="id41">
<h3>7.5.2   Examples</h3>
<div class="highlight"><pre><span class="nt">&lt;step</span> <span class="na">id=</span><span class="s">"test"</span> <span class="na">description=</span><span class="s">"Unittests with coverage.py information"</span><span class="nt">&gt;</span>
  <span class="nt">&lt;python:distutils</span> <span class="na">command=</span><span class="s">"unittest"</span>
      <span class="na">options=</span><span class="s">"--xml-output build/test-results.xml</span>
<span class="s">               --coverage-summary build/test-coverage.txt</span>
<span class="s">               --coverage-dir build/coverage</span>
<span class="s">               --coverage-method coverage"</span> <span class="nt">/&gt;</span>
  <span class="nt">&lt;python:unittest</span> <span class="na">file=</span><span class="s">"build/test-results.xml"</span><span class="nt">/&gt;</span>
  <span class="nt">&lt;python:coverage</span> <span class="na">summary=</span><span class="s">"build/test-coverage.txt"</span>
      <span class="na">coverdir=</span><span class="s">"build/coverage"</span>
      <span class="na">include=</span><span class="s">"mypackage/*"</span> <span class="na">exclude=</span><span class="s">"*/tests/*"</span> <span class="nt">/&gt;</span>
<span class="nt">&lt;/step&gt;</span>
</pre></div>
</div>
</div>
<div class="section" id="python-figleaf">
<h2>7.6   <tt class="docutils literal"><span class="pre">&lt;python:figleaf&gt;</span></tt></h2>
<p>Extracts coverage information recorded by <a class="reference external" href="http://darcs.idyll.org/~t/projects/figleaf/doc/">Figleaf</a>.</p>
<div class="section" id="id42">
<h3>7.6.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="19%">
<col width="81%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">summary</span></tt></td>
<td>Path to the summary file written by <tt class="docutils literal"><span class="pre">figleaf</span></tt>,
relative to the project source directory.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">include</span></tt></td>
<td>List of glob patterns (separated by space) that specify
which Python file should be included in the coverage report</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">exclude</span></tt></td>
<td>List of glob patterns (separated by space) that specify
which Python file should be excluded from the coverage
report</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="id43">
<h3>7.6.2   Examples</h3>
<div class="highlight"><pre><span class="nt">&lt;step</span> <span class="na">id=</span><span class="s">"test"</span> <span class="na">description=</span><span class="s">"Unittests with Figleaf coverage"</span><span class="nt">&gt;</span>
  <span class="nt">&lt;python:distutils</span> <span class="na">command=</span><span class="s">"unittest"</span>
      <span class="na">options=</span><span class="s">"--xml-output build/test-results.xml</span>
<span class="s">               --coverage-summary build/test-coverage.txt</span>
<span class="s">               --coverage-dir build/coverage</span>
<span class="s">               --coverage-method figleaf"</span> <span class="nt">/&gt;</span>
  <span class="nt">&lt;python:unittest</span> <span class="na">file=</span><span class="s">"build/test-results.xml"</span><span class="nt">/&gt;</span>
  <span class="nt">&lt;python:figleaf</span> <span class="na">summary=</span><span class="s">"build/test-coverage.txt"</span>
      <span class="na">include=</span><span class="s">"mypackage/*"</span> <span class="na">exclude=</span><span class="s">"*/tests/*"</span> <span class="nt">/&gt;</span>
<span class="nt">&lt;/step&gt;</span>
</pre></div>
</div>
</div>
<div class="section" id="python-pylint">
<h2>7.7   <tt class="docutils literal"><span class="pre">&lt;python:pylint&gt;</span></tt></h2>
<p>Extracts information from <a class="reference external" href="http://www.logilab.org/projects/pylint">Pylint</a> reports.</p>
<div class="section" id="id44">
<h3>7.7.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="19%">
<col width="81%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">file</span></tt></td>
<td>Path to the file containing the Pylint output, relative to
the project source directory.</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="id45">
<h3>7.7.2   Examples</h3>
<div class="highlight"><pre><span class="nt">&lt;python:pylint</span> <span class="na">file=</span><span class="s">"build/pylint.out"</span> <span class="nt">/&gt;</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="subversion-tools">
<h1>8   Subversion Tools</h1>
<p>A collection of recipe commands for working with the <a class="reference external" href="http://subversion.tigris.org/">Subversion</a> version
control system. This commands are commonly used as the first step of a build
recipe to actually pull the code that should be built from the repository.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name">
<col class="field-body">
<tbody valign="top">
<tr class="field"><th class="field-name">Namespace:</th><td class="field-body"><tt class="docutils literal"><span class="pre">http://bitten.edgewall.org/tools/svn</span></tt></td>
</tr>
<tr class="field"><th class="field-name">Common prefix:</th><td class="field-body"><tt class="docutils literal"><span class="pre">svn</span></tt></td>
</tr>
</tbody>
</table>
<div class="section" id="svn-checkout">
<h2>8.1   <tt class="docutils literal"><span class="pre">&lt;svn:checkout&gt;</span></tt></h2>
<p>Check out a working copy from a Subversion repository.</p>
<div class="section" id="id46">
<h3>8.1.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="22%">
<col width="78%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">url</span></tt></td>
<td>URL of the repository.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">path</span></tt></td>
<td>The path inside the repository that should be checked out.
You should normally set this to <tt class="docutils literal"><span class="pre">${path}</span></tt> so that the
path of the build configuration is used.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">revision</span></tt></td>
<td>The revision that should be checked out. You should
normally set this to <tt class="docutils literal"><span class="pre">${revision}</span></tt> so that the revision
of the build is used.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">dir</span></tt></td>
<td>Path specifying which directory the sources should be
checked out to (defaults to '.').</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">verbose</span></tt></td>
<td>Whether to log the list of checked out files (defaults to
False).</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">shared_path</span></tt></td>
<td>An optional shared directory to check the sources out in,
which will be reused for each subsequent build. This is
relative to the project directory, so for standard usage
set it to something like <tt class="docutils literal"><span class="pre">../trunk</span></tt></td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">username</span></tt></td>
<td>Username to pass for authentication (optional)</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">password</span></tt></td>
<td>Password to pass for authentication (optional)</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="id47">
<h3>8.1.2   Examples</h3>
<div class="highlight"><pre><span class="nt">&lt;svn:checkout</span> <span class="na">url=</span><span class="s">"http://svn.example.org/repos/myproject/"</span>
    <span class="na">path=</span><span class="s">"${path}"</span> <span class="na">revision=</span><span class="s">"${revision}"</span><span class="nt">/&gt;</span>
</pre></div>
<p>This checks out the a working copy into the current directory.</p>
</div>
</div>
<div class="section" id="svn-export">
<h2>8.2   <tt class="docutils literal"><span class="pre">&lt;svn:export&gt;</span></tt></h2>
<p>Download a file or directory from a Subversion repository. This is similar to
performing a checkout, but will not include the meta-data Subversion uses to
connect the local working copy to the repository (i.e. it does not include the
<tt class="docutils literal"><span class="pre">.svn</span></tt> directories.)</p>
<div class="section" id="id48">
<h3>8.2.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="19%">
<col width="81%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">url</span></tt></td>
<td>URL of the repository.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">path</span></tt></td>
<td>The path inside the repository that should be checked out.
You should normally set this to <tt class="docutils literal"><span class="pre">${path}</span></tt> so that the
path of the build configuration is used.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">revision</span></tt></td>
<td>The revision that should be checked out. You should
normally set this to <tt class="docutils literal"><span class="pre">${revision}</span></tt> so that the revision
of the build is used.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">dir</span></tt></td>
<td>Path specifying which directory the sources should be
exported to (defaults to '.')</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">username</span></tt></td>
<td>Username to pass for authentication (optional)</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">password</span></tt></td>
<td>Password to pass for authentication (optional)</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="id49">
<h3>8.2.2   Examples</h3>
<div class="highlight"><pre><span class="nt">&lt;svn:export</span> <span class="na">url=</span><span class="s">"http://svn.example.org/repos/myproject/"</span>
    <span class="na">path=</span><span class="s">"${path}"</span> <span class="na">revision=</span><span class="s">"${revision}"</span><span class="nt">/&gt;</span>
</pre></div>
<p>This downloads the file or directory at <tt class="docutils literal"><span class="pre">${path}</span></tt> from the Subversion
repository at <tt class="docutils literal"><span class="pre">http://svn.example.org/repos/myproject/</span></tt>. Variables are used
for the <tt class="docutils literal"><span class="pre">path</span></tt> and <tt class="docutils literal"><span class="pre">revision</span></tt> attributes so they are populated from the
properties of the build and build configuration.</p>
</div>
</div>
<div class="section" id="svn-update">
<h2>8.3   <tt class="docutils literal"><span class="pre">&lt;svn:update&gt;</span></tt></h2>
<p>Update an existing working copy from a Subversion repository to a specific
revision.</p>
<div class="section" id="id50">
<h3>8.3.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="19%">
<col width="81%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">revision</span></tt></td>
<td>The revision that should be checked out. You should
normally set this to <tt class="docutils literal"><span class="pre">${revision}</span></tt> so that the revision
of the build is used.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">dir</span></tt></td>
<td>Path specifying the directory containing the sources to be
updated (defaults to '.')</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="id51">
<h3>8.3.2   Examples</h3>
<div class="highlight"><pre><span class="nt">&lt;svn:update</span> <span class="na">revision=</span><span class="s">"${revision}"</span><span class="nt">/&gt;</span>
</pre></div>
<p>This updates the working copy in the current directory. The revision is
specified as a variable so that it is populated from the properties of the
build.</p>
</div>
</div>
</div>
<div class="section" id="xml-tools">
<h1>9   XML Tools</h1>
<p>A collection of recipe commands for XML processing.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name">
<col class="field-body">
<tbody valign="top">
<tr class="field"><th class="field-name">Namespace:</th><td class="field-body"><tt class="docutils literal"><span class="pre">http://bitten.edgewall.org/tools/xml</span></tt></td>
</tr>
<tr class="field"><th class="field-name">Common prefix:</th><td class="field-body"><tt class="docutils literal"><span class="pre">x</span></tt></td>
</tr>
</tbody>
</table>
<div class="section" id="x-transform">
<h2>9.1   <tt class="docutils literal"><span class="pre">&lt;x:transform&gt;</span></tt></h2>
<p>Apply an XSLT stylesheet .</p>
<p><strong>Note:</strong> This command requires either <a class="reference external" href="http://xmlsoft.org/XSLT/">libxslt</a> (with <a class="reference external" href="http://xmlsoft.org/XSLT/python.html">Python bindings</a>)
or, on Windows platforms, MSXML (version 3 or later) to be installed
on the slave machine.</p>
<div class="section" id="id52">
<h3>9.1.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="21%">
<col width="79%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">src</span></tt></td>
<td>Path of the source XML file.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">dest</span></tt></td>
<td>Path of the destition XML file.</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">stylesheet</span></tt></td>
<td>Path to the XSLT stylesheet file.</td>
</tr>
</tbody>
</table>
<p>All these are interpreted relative to the project source directory.</p>
</div>
<div class="section" id="id53">
<h3>9.1.2   Examples</h3>
<div class="highlight"><pre><span class="nt">&lt;x:transform</span> <span class="na">src=</span><span class="s">"src.xml"</span> <span class="na">dest=</span><span class="s">"dest.xml"</span> <span class="na">stylesheet=</span><span class="s">"util/convert.xsl"</span> <span class="nt">/&gt;</span>
</pre></div>
<p>This applies the stylesheet in <tt class="docutils literal"><span class="pre">util/convert.xsl</span></tt> to the source file
<tt class="docutils literal"><span class="pre">src.xml</span></tt>, and writes the resulting XML document to <tt class="docutils literal"><span class="pre">dest.xml</span></tt>.</p>
</div>
</div>
</div>
<div class="section" id="mercurial-tools">
<h1>10   Mercurial Tools</h1>
<p>A collection of recipe commands for working with <a class="reference external" href="http://mercurial.selenic.com/">Mercurial</a> (hg) repositories.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name">
<col class="field-body">
<tbody valign="top">
<tr class="field"><th class="field-name">Namespace:</th><td class="field-body"><tt class="docutils literal"><span class="pre">http://bitten.edgewall.org/tools/hg</span></tt></td>
</tr>
<tr class="field"><th class="field-name">Common prefix:</th><td class="field-body"><tt class="docutils literal"><span class="pre">hg</span></tt></td>
</tr>
</tbody>
</table>
<div class="section" id="hg-pull">
<h2>10.1   <tt class="docutils literal"><span class="pre">&lt;hg:pull&gt;</span></tt></h2>
<p>Pull changesets and updates a local Mercurial repository.</p>
<p>As the command depends on a pre-existing repository, bitten-slave must be
started with <tt class="docutils literal"><span class="pre">--build-dir=</span></tt> option for locating and working with the
repository. Also, seeing no remote location can be specified the repository
<tt class="docutils literal"><span class="pre">.hg/hgrc</span></tt> configuration file needs a <tt class="docutils literal"><span class="pre">[paths]</span> <span class="pre">default</span> <span class="pre">=</span> <span class="pre">....</span></tt> location
defined.</p>
<div class="section" id="id54">
<h3>10.1.1   Parameters</h3>
<table border="1" class="docutils">
<colgroup>
<col width="21%">
<col width="79%">
</colgroup>
<thead valign="bottom">
<tr><th class="head">Name</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="docutils literal"><span class="pre">revision</span></tt></td>
<td>The revision to update to (optional, defaults to tip).</td>
</tr>
<tr><td><tt class="docutils literal"><span class="pre">dir</span></tt></td>
<td>Local subdirectory with repository (optional,
defaults to '.').</td>
</tr>
</tbody>
</table>
<p>Paths are interpreted relative to the project source directory.</p>
</div>
<div class="section" id="id55">
<h3>10.1.2   Examples</h3>
<div class="highlight"><pre><span class="nt">&lt;hg:pull</span> <span class="na">revision=</span><span class="s">"${revision}"</span> <span class="na">dir=</span><span class="s">"src"</span> <span class="nt">/&gt;</span>
</pre></div>
<p>This updates the repository in <tt class="docutils literal"><span class="pre">src</span></tt> to the revision of the current build.</p>
</div>
</div>
</div>
    <div id="footer">
      Visit the Bitten open source project at
      <a href="http://bitten.edgewall.org/">http://bitten.edgewall.org/</a>
    </div>
  </div>
</body>
</html>
